var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as React from 'react';
import { colors, spacing, type, borderRadius } from '@workday/canvas-kit-react-core';
import { focusRing, hideMouseFocus, styled } from '@workday/canvas-kit-react-common';
import { useTab } from './Tabs';
var StyledButton = styled('button')(__assign(__assign(__assign(__assign(__assign({}, type.body), type.variant.button), { border: 'none', backgroundColor: 'transparent', flex: '0 0 auto', maxWidth: '280px', padding: spacing.s, boxSizing: 'border-box', cursor: 'pointer', color: colors.licorice300, position: 'relative', marginLeft: "" + spacing.xxxs, borderRadius: borderRadius.m + " " + borderRadius.m + " 0px 0px", transition: 'background 150ms ease, color 150ms ease', '&:first-of-type': {
        marginLeft: 0,
    } }), hideMouseFocus), { '&:hover, &:focus': {
        backgroundColor: colors.soap200,
        color: colors.blackPepper400,
    }, '&:focus': __assign({ outline: "none" }, focusRing({ inset: 'outer', width: 0, separation: 2 })) }), function (_a) {
    var isSelected = _a.isSelected;
    if (isSelected) {
        return {
            color: colors.blueberry400,
            cursor: 'default',
            '&:after': {
                position: 'absolute',
                height: spacing.xxxs,
                borderRadius: borderRadius.m + " " + borderRadius.m + " 0px 0px",
                backgroundColor: colors.blueberry400,
                bottom: 0,
                content: "''",
                left: 0,
                marginTop: '-2px',
                width: '100%',
            },
            '&:hover, &:focus': {
                backgroundColor: "transparent",
                color: colors.blueberry400,
            },
        };
    }
    return {};
});
var Tab = function (_a) {
    var _b = _a.name, name = _b === void 0 ? '' : _b, children = _a.children, elemProps = __rest(_a, ["name", "children"]);
    var _c = useTab(), id = _c.id, intentTab = _c.intentTab, resetIntentTab = _c.resetIntentTab, activeTab = _c.activeTab, setActiveTab = _c.setActiveTab, setSelectedTabRect = _c.setSelectedTabRect, registerTab = _c.registerTab, unregisterTab = _c.unregisterTab;
    var tabRef = React.useRef(null);
    var _d = React.useState(name), tabName = _d[0], setTabName = _d[1];
    React.useLayoutEffect(function () {
        var tabElement = tabRef.current;
        var tabName = registerTab(tabElement, name);
        setTabName(tabName);
        return function () {
            unregisterTab(tabElement);
        };
    }, [name, registerTab, unregisterTab]);
    var onSelect = function () {
        setActiveTab(tabName);
    };
    var isSelected = !!tabName && activeTab === tabName;
    React.useLayoutEffect(function () {
        if (isSelected && tabRef.current) {
            setSelectedTabRect(tabRef.current.getBoundingClientRect());
        }
    }, [isSelected, tabRef, setSelectedTabRect, tabName, intentTab]);
    return (React.createElement(StyledButton, __assign({ ref: tabRef, role: "tab", id: "tab-" + id + "-" + tabName, tabIndex: !!tabName && intentTab === tabName ? undefined : -1, "aria-selected": isSelected ? true : undefined, "aria-controls": "tabpanel-" + id + "-" + tabName, onClick: onSelect, onBlur: resetIntentTab, isSelected: isSelected }, elemProps), children));
};
export default Tab;
